'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _events = require('events');

var _events2 = _interopRequireDefault(_events);

var _utilMix = require('util-mix');

var _utilMix2 = _interopRequireDefault(_utilMix);

var _cssModuleDeps = require('css-module-deps');

var _cssModuleDeps2 = _interopRequireDefault(_cssModuleDeps);

var _through2 = require('through2');

var _through22 = _interopRequireDefault(_through2);

var _resolve = require('resolve');

var _resolve2 = _interopRequireDefault(_resolve);

var _readOnlyStream = require('read-only-stream');

var _readOnlyStream2 = _interopRequireDefault(_readOnlyStream);

var _depsTopoSort = require('deps-topo-sort');

var _depsTopoSort2 = _interopRequireDefault(_depsTopoSort);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _labeledStreamSplicer = require('labeled-stream-splicer');

var _labeledStreamSplicer2 = _interopRequireDefault(_labeledStreamSplicer);

var _sinkTransform = require('sink-transform');

var _sinkTransform2 = _interopRequireDefault(_sinkTransform);

var Depsify = (function (_EventEmitter) {
  _inherits(Depsify, _EventEmitter);

  function Depsify(entries, opts) {
    var _this = this;

    _classCallCheck(this, Depsify);

    _get(Object.getPrototypeOf(Depsify.prototype), 'constructor', this).call(this);
    if (typeof entries === 'string' || Array.isArray(entries)) {
      opts = (0, _utilMix2['default'])({}, opts, {
        entries: [].concat(opts.entries || [], entries)
      });
    } else {
      opts = (0, _utilMix2['default'])({}, entries, opts);
    }
    this._options = opts;
    opts.basedir = opts.basedir || process.cwd();

    this.pipeline = this._createPipeline(opts);[].concat(opts.entries).filter(Boolean).forEach(function (file) {
      _this.add(file, { basedir: opts.basedir });
    });[].concat(opts.plugin).filter(Boolean).forEach(function (p) {
      _this.plugin(p, { basedir: opts.basedir });
    });
  }

  _createClass(Depsify, [{
    key: '_createPipeline',
    value: function _createPipeline(opts) {
      var _this2 = this;

      this._mdeps = new _cssModuleDeps2['default']((0, _utilMix2['default'])({}, opts));
      this._mdeps.on('file', function (file) {
        pipeline.emit('file', file);
        _this2.emit('file', file);
      });
      this._mdeps.on('package', function (pkg) {
        pipeline.emit('package', pkg);
        _this2.emit('package', pkg);
      });
      this._mdeps.on('transform', function (tr, file) {
        pipeline.emit('transform', tr, file);
        _this2.emit('transform', tr, file);
      });

      if (opts.pack) {
        this.pack = opts.pack;
      }
      // for factor-bundle
      this._bpack = this.pack(opts);

      var pipeline = _labeledStreamSplicer2['default'].obj(['record', [this._recorder()], 'deps', [this._mdeps], 'unbom', [this._unbom()], 'syntax', [], 'sort', [], 'dedupe', [], 'label', [], 'emit-deps', [this._emitDeps()], 'debug', [], 'pack', [this._bpack], 'wrap', []]);

      return pipeline;
    }
  }, {
    key: '_unbom',
    value: function _unbom() {
      return _through22['default'].obj(function (row, enc, next) {
        if (/^\ufeff/.test(row.source)) {
          row.source = row.source.replace(/^\ufeff/, '');
        }
        this.push(row);
        next();
      });
    }
  }, {
    key: '_emitDeps',
    value: function _emitDeps() {
      var self = this;
      return _through22['default'].obj(function (row, enc, next) {
        self.emit('dep', row);
        this.push(row);
        next();
      });
    }
  }, {
    key: '_recorder',
    value: function _recorder() {
      var _this3 = this;

      this._recorded = [];
      return _through22['default'].obj(function (row, _, next) {
        _this3._recorded.push(row);
        next(null, row);
      });
    }
  }, {
    key: 'pack',
    value: function pack() {
      return [_sinkTransform2['default'].obj(function (rows, done) {
        var _this4 = this;

        rows.sort(function (a, b) {
          return a.file < b.file ? -1 : 1;
        }).forEach(function (row) {
          // to use toposort
          row.id = row.file;
          _this4.push(row);
        });
        done();
      }), (0, _depsTopoSort2['default'])(), _through22['default'].obj(function (row, _, next) {
        next(null, row.source);
      })];
    }
  }, {
    key: 'add',
    value: function add(file, opts) {
      var _this5 = this;

      opts = opts || {};
      if (Array.isArray(file)) {
        file.forEach(function (f) {
          _this5.add(f, opts);
        });
      } else if (typeof file === 'string') {
        file = _path2['default'].resolve(opts.basedir || this._options.basedir, file);
        this.pipeline.write({ file: file });
      } else {
        this.pipeline.write((0, _utilMix2['default'])({ basedir: this._options.basedir }, file, opts));
      }
      return this;
    }
  }, {
    key: 'processor',
    value: function processor(p) {
      this.pipeline.write({ processor: p });
      return this;
    }
  }, {
    key: 'reset',
    value: function reset() {
      this.pipeline = this._createPipeline(this._options);
      this._bundled = false;
      this.emit('reset');
    }
  }, {
    key: 'plugin',
    value: function plugin(p, opts) {
      if (Array.isArray(p)) {
        opts = p[1];
        p = p[0];
      }
      var basedir = opts && opts.basedir || this._options.basedir;
      if (typeof p === 'function') {
        p(this, opts);
      } else {
        var pfile = _resolve2['default'].sync(p, { basedir: basedir });
        var f = require(pfile);
        f(this, opts);
      }
      return this;
    }
  }, {
    key: 'bundle',
    value: function bundle() {
      var _this6 = this;

      if (this._bundled) {
        var recorded = this._recorded;
        this.reset();
        recorded.forEach(function (x) {
          _this6.pipeline.write(x);
        });
      }
      var output = (0, _readOnlyStream2['default'])(this.pipeline);
      this.emit('bundle', output);
      this.pipeline.end();
      this._bundled = true;

      return output;
    }
  }]);

  return Depsify;
})(_events2['default']);

exports['default'] = Depsify;
module.exports = exports['default'];